routes/web.php
<?php

use App\Http\Controllers\AdminBookingController;
use App\Http\Controllers\BookController;
use App\Http\Controllers\BookingAdminController;
use App\Http\Controllers\BookingController;
use App\Http\Controllers\BorrowController;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\DashboardController;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\StudentBorrowController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// student start
    // home
    Route::get('/', [HomeController::class, 'index'])->name('home');
    Route::get('home/show/{id}', [HomeController::class, 'show'])->name('home.user.show');
    Route::get('studentborrow', [StudentBorrowController::class, 'index'])->name('studentborrow.index');

    // booking
    Route::resource('booking', BookingController::class);
// student end

// admin start
    // dashboard
    Route::get('dashboard', [DashboardController::class, 'index'])->name('dashboard')->middleware('is_admin');

    // buku
    Route::resource('book', BookController::class)->middleware('is_admin');

    // category
    Route::resource('category', CategoryController::class)->middleware('is_admin');

    // borrow
    Route::get('borrow/{any}', [BorrowController::class, 'index'])->name('borrow.index')->middleware('is_admin');
    Route::post('borrow/', [BorrowController::class, 'store'])->name('borrow.store')->middleware('is_admin');
    Route::get('borrow/{id}/edit', [BorrowController::class, 'edit'])->name('borrow.edit')->middleware('is_admin');
    Route::put('borrow/{id}', [BorrowController::class, 'update'])->name('borrow.update')->middleware('is_admin');
    Route::delete('borrow/{id}/{any}', [BorrowController::class, 'destroy'])->name('borrow.destroy')->middleware('is_admin');

    // booking admin
    Route::resource('adminbooking', AdminBookingController::class)->middleware('is_admin');
    Route::get('adminbooking/create/{id}', [AdminBookingController::class, 'create'])->name('adminbooking.create')->middleware('is_admin');

    //user
    Route::middleware('is_admin')->group(function() {
        Route::get('user/{any}', [UserController::class, 'index'])->name('user.index');
        Route::get('user/show/{id}', [UserController::class, 'show'])->name('user.show');
        Route::delete('user/{id}/{any}', [UserController::class, 'destroy'])->name('user.destroy');
        Route::put('user/{id}', [UserController::class, 'update'])->name('user.update');
    });
// admin end

Auth::routes();

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;
    protected $guarded = [];
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = DB::table('categories')
            ->orderBy('name')
            ->get();

        return view('pages.admin.category.index', [
            'categories' => $categories,
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('pages.admin.category.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // validasi
        $validatedData = $request->validate([
            'name' => 'required',
            'location' => 'required',
            'floor' => 'required',
        ]);

        // data tambahan
        $addData = [
            'created_at' => now(),
            'updated_at' => now(),
        ];

        // merge array
        $data = array_merge($validatedData, $addData);

        // simpan 
        DB::table('categories')->insert($data);

        return redirect()->route('category.index')->with('pesan', 'Tambah kategori berhasil');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // ambil data
        $category = DB::table('categories')
            ->where('id', $id)
            ->first();

        return view('pages.admin.category.edit', [
            'category' => $category
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        // validasi
        $validatedData = $request->validate([
            'name' => 'required',
            'location' => 'required',
            'floor' => 'required',
        ]);

        // data tambahan
        $addData = [
            'updated_at' => now(),
        ];

        // merge array
        $data = array_merge($validatedData, $addData);

        // update 
        DB::table('categories')
            ->where('id', $id)
            ->update($data);

        return redirect()->route('category.index')->with('pesan', 'Ubah kategori berhasil');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        DB::table('categories')
            ->where('id', $id)
            ->delete();

        return redirect()->route('category.index')->with('pesan', 'Hapus kategori berhasil');
    }
}

resources/views/pages/admin/category/create.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Tambah Kategori')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    {{-- breadcrumb --}}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('category.index') }}">Kategori</a></li>
            <li class="breadcrumb-item active" aria-current="page">Tambah Kategori</li>
        </ol>
    </nav>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            <!-- Page Heading -->
            <h1 class="h3 mb-4 text-gray-800 text-center font-weight-bold">Tambah Kategori</h1>

            <div class="row justify-content-center mb-4">
                <div class="col-md-10">

                    {{-- form --}}
                    <form action="{{ route('category.store') }}" method="post">
                        @csrf
                        <div class="form-group">
                            <label for="name">Nama Kategori</label>
                            <input type="text" class="form-control @error('name') is-invalid @enderror" id="name"
                                name="name" placeholder="Ex: Psikologi" value="{{ old('name') }}" autofocus>
                            @error('name')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="location">Lokasi Penyimpanan</label>
                            <input type="text" class="form-control @error('location') is-invalid @enderror"
                                id="location" name="location" placeholder="Ex: Rak Buku 1"
                                value="{{ old('location') }}">
                            @error('location')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="floor">Lantai Perpustakaan</label>
                            <select class="form-control @error('floor') is-invalid @enderror" id="floor" name="floor">
                                <option value="1" {{ old('floor') == '1' ? 'selected' : '' }}>1</option>
                                <option value="2" {{ old('floor') == '2' ? 'selected' : '' }}>2</option>
                                <option value="3" {{ old('floor') == '3' ? 'selected' : '' }}>3</option>
                            </select>
                            @error('floor')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary d-block w-100 text-center">Simpan</button>
                    </form>

                </div>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->
@endsection

resources/views/pages/admin/category/edit.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Ubah Kategori')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    {{-- breadcrumb --}}
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item"><a href="{{ route('category.index') }}">Kategori</a></li>
            <li class="breadcrumb-item active" aria-current="page">Ubah Kategori</li>
        </ol>
    </nav>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            <!-- Page Heading -->
            <h1 class="h3 mb-4 text-gray-800 text-center font-weight-bold">Ubah Kategori</h1>

            <div class="row justify-content-center mb-4">
                <div class="col-md-10">

                    {{-- form --}}
                    <form action="{{ route('category.update', $category->id) }}" method="post">
                        @csrf
                        @method('put')
                        <div class="form-group">
                            <label for="name">Nama Kategori</label>
                            <input type="text" class="form-control @error('name') is-invalid @enderror" id="name"
                                name="name" placeholder="Ex: Psikologi"
                                value="{{ old('name') ? old('name') : $category->name }}" autofocus>
                            @error('name')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="location">Lokasi Penyimpanan</label>
                            <input type="text" class="form-control @error('location') is-invalid @enderror"
                                id="location" name="location" placeholder="Ex: Rak Buku 1"
                                value="{{ old('location') ? old('location') : $category->location }}">
                            @error('location')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="floor">Lantai Perpustakaan</label>
                            <select class="form-control @error('floor') is-invalid @enderror" id="floor" name="floor">
                                <option value="1" {{ (old('floor') ?? $category->floor) == '1' ? 'selected' : '' }}>1
                                </option>
                                <option value="2" {{ (old('floor') ?? $category->floor) == '2' ? 'selected' : '' }}>2
                                </option>
                                <option value="3" {{ (old('floor') ?? $category->floor) == '3' ? 'selected' : '' }}>3
                                </option>
                            </select>
                            @error('floor')
                            <div class="text-danger">{{ $message }}</div>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary d-block w-100 text-center">Simpan</button>
                    </form>

                </div>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->
@endsection

resources/views/pages/admin/category/index.blade.php
@extends('layouts.admin')

@section('title', 'PerpustakaanXYZ | Kategori')

@section('content')
<!-- Begin Page Content -->
<div class="container-fluid">

    <!-- Page Heading -->
    <h1 class="h3 mb-4 text-gray-800">Daftar Kategori</h1>

    {{-- content --}}
    <div class="card shadow-sm">
        <div class="container py-4">

            {{-- pesan --}}
            @if (session()->has('pesan'))
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                {{ session()->get('pesan') }}
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            @endif

            {{-- button --}}
            <a href="{{ route('category.create') }}" class="btn btn-primary mb-3">Tambah Kategori</a>

            {{-- table --}}
            <div class="table-responsive">
                <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                    <thead>
                        <tr>
                            <th>#</th>
                            <th>Nama</th>
                            <th>Lokasi Penyimpanan</th>
                            <th>Lantai Perpustakaan</th>
                            <th>Aksi</th>
                        </tr>
                    </thead>
                    <tbody>

                        {{-- tampil data --}}
                        @forelse ($categories as $category)
                        <tr>
                            <td>{{ $loop->iteration }}</td>
                            <td>{{ $category->name }}</td>
                            <td>{{ $category->location }}</td>
                            <td>{{ $category->floor }}</td>
                            <td class="d-flex justify-content-center">

                                {{-- edit --}}
                                <a href="{{ route('category.edit', $category->id) }}" class="btn btn-secondary mr-2"
                                    title="Ubah">
                                    <i class="fas fa-edit"></i>
                                </a>

                                <!-- button delete modal -->
                                <button type="button" class="btn btn-danger btn-delete" data-toggle="modal"
                                    data-target="#deleteModal" data-id={{ $category->id }} title="Hapus">
                                    <i class="fas fa-trash"></i>
                                </button>

                            </td>
                        </tr>
                        @empty
                        <tr>
                            <td colspan="5" class="text-center">Tidak ada data</td>
                        </tr>
                        @endforelse

                    </tbody>
                </table>
            </div>

        </div>
    </div>

</div>
<!-- /.container-fluid -->

@endsection

{{-- melampirkan push deleteModal --}}
@include('includes.deleteModal')

{{-- melampirkan push css dan js datatables --}}
@include('includes.datatables')

{{-- push script deleteJS --}}
@push('scripts')
<script>
    // menangkap nilai id lalu mengeneratenya ke dalam url action form 
    $('.btn-delete').click(function () {
        let idDelete = $(this).attr('data-id');
        $('#deleteForm').attr('action', '/category/' + idDelete);
    })

    // jika ya ditekan, maka submit form
    $('#deleteForm [type="submit"]').click(function () {
        $('#deleteForm').submit();
    })

</script>
@endpush